;--------------------         
SWFSR01:         
	mvf	FSR0L,W,ACCE
	xorf	FSR1BUF,W,ACCE
	xorf	FSR0L,F,ACCE
	xorf	FSR1BUF,F,ACCE
	ret
;--------------------         
Delay2ms:   ; about 6ms
       mvl     1
       mvf     temr,F,ACCE
       mvl     100
       jmp     Delay10ms_1
Delay10ms:
        mvl     20
        mvf     temr,F,ACCE
     Delay10ms_2:   
        mvl     0
     Delay10ms_1:   
        dcsz    WREG,F,ACCE
        jmp     Delay10ms_1
        dcsz    temr,F,ACCE
        jmp     Delay10ms_2
        ret  
;=================================          
ADCINISet:
       mvl     11100000b
  ADCINISet1:
       mvf     ADCCN3,F,ACCE
       mvl     11110000b
       mvf     PWRCN,F,ACCE      
       mvl     00011110b
       mvf     ADCCN1,F,ACCE
       mvl     00001101b
       mvf     ADCCN2,F,ACCE
       mvl     01101100b
       mvf     AINET1,F,ACCE
       mvl     01000110b
       mvf     AINET2,F,ACCE
       call     delay2ms
       bsf      ADCCN1,ENADC,ACCE
       ret
;=================================          
INISet:       
       bsf     MCKCN3,PERCK,ACCE   ; Select clock source = HS clock / 32      
       mvl     11000011b           ; Watchdog enable 1/s
       mvf     TMACN,F,ACCE     
      ;==========INTE Set============================
       mvl       01001000b
       mvf       INTE1,F,ACCE
      ;======================================
       mvl      256-3 
       mvf      GvupADC,F,ACCE
      clrf      INTF1,ACCE   
      call    ClearLCD
        mvl     10
        mvf     HTMB,F,ACCE      ; 0 10
        mvl     5
        mvf     HTMBZ,F,ACCE     ; íw5
        mvl     30
        mvf     HTotalTM,F,ACCE  ;`qɶ30
      ret
;==============================
ADCFillStb:
         mvl     256-8
         mvf    ADStbcnt,F,acce
         bcf     INTE1,GIE,ACCE
         call   ADCFill
         bsf     INTE1,GIE,ACCE
         bcf     ADCFg,b_stable,ACCE   
         bcf     ADCFg,b_ADCOK,ACCE
         ret
ADCFill:
         mvl     ADBUF
         mvf     FSR0L,F,ACCE
         mvl     7
         mvf     Temp+5,F,ACCE
      ADCFill_LOOP:   
         mvff    ADNEWL,INDF0
         inf     FSR0L,F,ACCE
         mvff    ADNEWM,INDF0
         inf     FSR0L,F,ACCE
         mvff    ADNEWH,INDF0
         inf     FSR0L,F,ACCE
         dcsz    Temp+5,F,ACCE
         jmp     ADCFill_LOOP
         mvff    ADCRL,ADA1
         mvff    ADCRM,ADA1+1
         mvff    ADCRH,ADA1+2
         ret
;==============================
CKHTEMPSN:
        bsf      status,c,acce     
        tfsz     Temp+2,ACCE
        ret
        mvf      Temp+3,W,ACCE
        subf     Temp,W,ACCE
        mvf      Temp+3+1,W,ACCE
        subc     Temp+1,W,ACCE
        ret
        
;===========================================       
PROCAMainPRO:
	call	ADCSUBZero
     ;=======================  
       mvff    temp,HADWeight
       mvff    temp+1,HADWeight+1
       mvff    temp+2,HADWeight+2
     ;=======================  
       bcf     ADCFg,b_neg,ACCE 
       btss    Temp+2,7,ACCE
       jmp     PROCA_MM1
       bsf     ADCFg,b_neg,ACCE 
       call	COMFTEMP
   PROCA_MM1:
        ret
;============================================================
ADCSUBZero:
       mvf     Zero,W,ACCE
       subf    ADCOUTL,W,ACCE
       mvf     Temp,F,ACCE
       mvf     Zero+1,W,ACCE
       subc    ADCOUTM,W,ACCE   
       mvf     Temp+1,F,ACCE
       mvf     ZeroH,W,ACCE
       subc    ADCOUTH,W,ACCE   
       mvf     Temp+2,F,ACCE
	ret  
;==========================================================
COMFTEMP:
       comf    Temp,F,ACCE
       comf    Temp+1,F,ACCE
       comf    Temp+2,F,ACCE
       mvl	0
       inf	Temp,F,ACCE
       addc	Temp+1,F,ACCE
       addc	Temp+2,F,ACCE
       ret	       
;=============================================================
Giveup2TimeADC:     
       mvl     3
    Gp2TimeADC_1:   
       btss    INTF1,ADCIF,ACCE
       jmp     Gp2TimeADC_1
       bcf     INTF1,ADCIF,ACCE
       dcsz    WREG,F,ACCE
       jmp     Gp2TimeADC_1
       ret

;=============================================================
ZeroTrace:       
       btss    ADCFg,b_stable,ACCE
       jmp     ZeroTrac_NSTB
       tfsz    Tm1s,ACCE
       jmp     ZeroTrac_ZSTB
       call    CKOVZero
       btsz    Wreg,0,ACCE
       jmp     ZeroTrac_NSTB
       mvf     Zero,W,ACCE
       subf    ADStable,W,ACCE
       mvf     Temp,F,ACCE
       mvf     Zero+1,W,ACCE
       subc    ADStable+1,W,ACCE
       mvf     Temp+1,F,ACCE
       mvf     ZeroH,W,ACCE
       subc    ADStable+2,W,ACCE
       mvf     Temp+2,F,ACCE
       bcf     ADCFg,b_neg,ACCE 
       btss    Temp+2,7,ACCE
       jmp     ZeroTrac_NTB1
       bsf     ADCFg,b_neg,ACCE
       call	COMFTEMP 
   ZeroTrac_NTB1:
       tfsz    Temp+2,ACCE
       jmp      ZeroTrac_NSTB
       tfsz    Temp+1,ACCE
       jmp      ZeroTrac_NSTB
       mvf     sn,W,ACCE
       cpsl    temp,acce 
       jmp      ZeroTrac_NSTB
   ZeroTrac_NTB2:
       mvff    ADStable,Zero
       mvff    ADStable+1,Zero+1
       mvff    ADStable+2,ZeroH
  ZeroTrac_NSTB:
       mvl     200
       mvf     Tm1s,F,ACCE
  ZeroTrac_ZSTB:     
       ret       
;===============================================================       
;pGTemp - ADAZ <40 h C = 0
ADCLess40C:
       mvf    Zero,w,acce
       subf   temp,f,acce 
       mvf    Zero+1,w,acce
       subc   temp+1,f,acce 
       mvf    Zero+2,w,acce
       subc   temp+2,f,acce 
       btss   temp+2,7,acce
       jmp    ADCStartUP_3
	call	COMFTEMP
    ADCStartUP_3:  
	call	GetValue
	mvl	40
	subf	Temp,W,ACCE
	mvl	0
	subc	Temp+1,W,ACCE
	ret 
;================================================
GetValue:	                     
       mvl      Temp
       mvf      md1,F,ACCE
       mvl      CWeight
       mvf      md2,F,ACCE
       mvl      Temp+5
       mvf      md3,F,ACCE
       mvl      3
       mvf      mdl1,F,ACCE
       mvl      2
       mvf      mdl2,F,ACCE
       call     multiply
       
       mvff     Adspan,temp+2
       mvff     Adspan+1,temp+2+1
       mvff     AdspanH,temp+2+2
       mvl      Temp+5
       mvf      md1,F,ACCE
       mvl     temp+2
       mvf     md2,F,ACCE
       mvl     temp
       mvf     md3,F,ACCE
       mvl     5
       mvf     mdl1,F,ACCE
       mvl     3
       mvf     mdl2,F,ACCE
       mvl     2
       mvf     mdl3,F,ACCE
       jmp    divide
;=======================================       
 PUTZero:        
        mvf     ADStable,W,ACCE
        mvf     adaz,F,ACCE
        mvf     Zero,F,ACCE
        mvf     ADStable+1,W,ACCE
        mvf     adaz+1,F,ACCE
        mvf     Zero+1,F,ACCE
        mvf     ADStable+2,W,ACCE
        mvf     adazh,F,ACCE
        mvf     ZeroH,F,ACCE
        ret
      